source: packages/net/wing/files/lib/network/wing.sh @ 27643

Last change on this file since 27643 was 27643, checked in by swalker, 5 years ago

[packages] wing: update to 20110709 (#9722)

  • Signed-off-by: Roberto Riggio <roberto.riggio at create-net.org>
  • remove unrecognized configure options
  • remove trailing whitespace
File size: 4.4 KB
Line 
1
2scan_wing() {
3        config_set "$1" device "wing-$1"
4}
5
6coldplug_interface_wing() {
7        setup_interface_wing "wing-$1" "$1"
8}
9
10stop_interface_wing() {
11        local config="$1"
12        local iface="wing-$config"
13        env -i ACTION="ifdown" INTERFACE="$config" DEVICE="$iface" PROTO=wing /sbin/hotplug-call "iface" &
14        [ -f "/var/run/$iface.pid" ] && {
15                kill -9 $(cat /var/run/$iface.pid)
16                rm /var/run/$iface.pid
17        }
18}
19
20setup_interface_wing() {
21
22        local iface="$1"
23        local config="$2"
24
25        local hwmodes=""
26        local freqs=""
27        local ifnames=""
28        local hwaddrs=""
29
30        config_load wireless
31        config_foreach wing_list_interfaces wifi-iface
32
33        # start click router
34        if [ "$hwmodes" = "" -o "$freqs" = "" -o "$ifnames" = "" -o "$hwaddrs" = "" ]; then
35                logger -t "$config" "No raw interfaces available. Exiting."
36                exit 1
37        fi
38
39        local profile rc ls metric prefix period tau debug
40
41        config_get profile $config profile "bulk"
42        config_get rc $config rc "minstrel"
43        config_get ls $config ls "fcfs"
44        config_get metric $config metric "wcett"
45        config_get prefix $config prefix "6"
46        config_get period $config period "10000"
47        config_get tau $config tau "100000"
48        config_get_bool debug $config debug "false"
49
50        local hwaddr=$(echo $hwaddrs | sed 's/ .*//');
51        local ipaddr=$(printf "$prefix.%d.%d.%d" $(echo $hwaddr | awk -F: '{printf "0x%s 0x%s 0x%s",$4,$5,$6}'))
52        local bcast="$prefix.255.255.255"
53        local netmask=255.0.0.0
54
55        if ! wing_template_available "profile" "$profile"; then
56                logger -t "$config" "Unable to configure router. Exiting."
57                exit 1
58        fi
59
60        if ! wing_template_available "rc" "$rc"; then
61                logger -t "$config" "Unable to configure rate control. Exiting."
62                exit 1
63        fi
64
65        if ! wing_template_available "ls" "$ls"; then
66                logger -t "$config" "Unable to configure link scheduler. Exiting."
67                exit 1
68        fi
69
70        if [ "$profile" = "" -o "$rc" = "" ]; then
71                logger -t "$config" "Unable to generate template. Exiting."
72                exit 1
73        fi
74
75        [ "$debug" == 0 ] && dbg="" || dbg="-d"
76
77        /usr/bin/click_config -p $profile -r $rc -s $ls -l $metric \
78                -m "$hwmodes" -c "$freqs" -n "$ifnames" -a "$hwaddrs" $dbg \
79                | sed -e "s/__XR_IFNAME__/$iface/g" \
80                | sed -e "s/__XR_IP__/$ipaddr/g" \
81                | sed -e "s/__XR_BCAST__/$bcast/g" \
82                | sed -e "s/__XR_NM__/$netmask/g" \
83                | sed -e "s/__XR_PERIOD__/$period/g" \
84                | sed -e "s/__XR_TAU__/$tau/g" > /tmp/$iface.click
85
86        /usr/bin/click-align /tmp/$iface.click > /tmp/$iface-aligned.click 2>/var/log/$iface.log
87        [ ! -c /dev/net/tun ] && {
88                mkdir -p /dev/net/
89                mknod /dev/net/tun c 10 200
90                if [ ! -c /dev/net/tun ]; then
91                        logger -t "$config" "Device not available (/dev/net/tun). Exiting."
92                        exit 1
93                fi
94        }
95
96        # creating the tun interface below will trigger a net subsystem event
97        # prevent it from touching iface by disabling .auto here
98        uci_set_state network "$config" auto 0
99
100        (/usr/bin/click /tmp/$iface-aligned.click >> /var/log/$iface.log 2>&1 &) &
101        sleep 2
102        ps | grep /usr/bin/click | grep -q -v grep || {
103                logger -t "$config" "Unable to start click. Exiting."
104                exit 1
105        }
106
107        ps | grep /usr/bin/click | grep -v grep | awk '{print $1}' > /var/run/$iface.pid
108
109        ifconfig "$iface" "$ipaddr" netmask "$netmask"
110        route add default dev "$iface"
111
112        uci_set_state network $config ifname "$iface"
113        uci_set_state network $config ipaddr "$ipaddr"
114        uci_set_state network $config netmask "$netmask"
115        uci_set_state network $config gateway "0.0.0.0"
116
117        env -i ACTION="ifup" INTERFACE="$config" DEVICE="$iface" PROTO=wing /sbin/hotplug-call "iface" &
118
119}
120
121wing_template_available() { # prefix, template, default
122        local template="/etc/wing/$1.$2.click"
123        [ ! -f $template ] && {
124                return 1
125        }
126        return 0
127}
128
129wing_list_interfaces() {
130        local channel freq hwmode hwaddr ifname mode
131        config_get mode $1 mode
132        config_get_bool up $1 up
133        [ "$up" = "1" -a "$mode" = "monitor" ] || return 0
134        config_get ifname $1 ifname
135        config_get device $1 device
136        config_get hwmode $device hwmode "11bg"
137        config_get channel $device channel "0"
138        [ "$channel" = "0" -o "$channel" = "auto" ] && {
139                logger -t "$device" "Channel not specified. Ignoring."
140                return 0
141        }
142        freq=$(iwlist $ifname freq | sed -n "s/^.*Channel 0*$channel : \([0-9.]*\).*/\1/p" | awk '{print $1*1000}')
143        hwaddr=$(/sbin/ifconfig $ifname 2>&1 | sed -n 's/^.*HWaddr \([0-9A-Za-z\-]*\).*/\1/p' | sed -e 's/\-/:/g' | cut -c1-17)
144        freqs=${freqs:+"$freqs "}$freq
145        hwmodes=${hwmodes:+"$hwmodes "}$hwmode
146        hwaddrs=${hwaddrs:+"$hwaddrs "}$hwaddr
147        ifnames=${ifnames:+"$ifnames "}$ifname
148        /sbin/ifconfig $ifname mtu 1900
149        /sbin/ifconfig $ifname txqueuelen 5
150        /sbin/ifconfig $ifname up
151}
152
Note: See TracBrowser for help on using the repository browser.